<apex:page tabstyle="SM_Run_Sheet_Detail__c" title="Edit Sand Request" id="SM_EditRunSheet" standardcontroller="SM_Run_Sheet__c" extensions="SM_RunSheetControllerX" cache="true">

    <apex:includeScript value="https://code.jquery.com/jquery-1.10.2.js" />
    <apex:includeScript value="https://code.jquery.com/ui/1.10.4/jquery-ui.js" />
    <apex:styleSheet value="https://code.jquery.com/ui/1.10.4/themes/ui-lightness/jquery-ui.css" />
    
    <style>
        .1vendorTable {border:1px solid black;}
        
        .displayNone { 
            display:none; 
        }
        .displayBlock {
            display:block;
        }
        .ui-autocomplete-loading { 
            background: white url(/img/loading32.gif) right center no-repeat;
            background-size:15px 15px; 
        }
        .placeHolder {
            font-style: italic;
        }
    </style>

    <script type="text/javascript">
        if({!IsSandLead || IsHogAdmin} != true)
        {
            if({!ViewSheet.Is_Current_Date__c} == true)
            {
                window.location = '/apex/SM_AddRunSheet?wellid={!ViewSheet.Well_Location__c}';
            }
            else
            {
                window.location = '/apex/SM_ViewRunSheet?id={!ViewSheet.Id}';
            }
        }
    </script>

    <apex:sectionHeader title="Sand Request" subtitle="{!ViewSheet.Name}" rendered="{!ViewSheet.Id != null && (IsSandLead == true || IsHogAdmin == true)}" />
    <apex:pageMessages id="messages" escape="false" rendered="{!ViewSheet.Id != null && (IsSandLead == true || IsHogAdmin == true)}" />

    <apex:form id="smeditform" rendered="{!ViewSheet.Id != null && (IsSandLead == true || IsHogAdmin == true)}">

        <apex:actionstatus id="ajaxStatus">
            <apex:facet name="start" >
                <div class="waitingSearchDiv" id="el_loading" style="background-color: #dcd6d6; height: 100%; opacity: 0.65; width: 100%;">
                    <div class="waitingHolder" style="top: 150px; width: 200px; height: 40px; border: 1px solid black; background-color: white;">
                        <p>
                            <img class="waitingImage" src="/img/loading.gif" title="Please Wait..." />
                            <span class="waitingDescription">Please Wait...</span>
                        </p>
                    </div>
                </div>
            </apex:facet>
        </apex:actionstatus>

        <apex:pageBlock id="pbView" mode="detail">

            <apex:pageBlockButtons location="bottom" id="pagebuttons">
                <apex:actionstatus id="buttonstatus">

                    <apex:facet name="stop">
                        <apex:outputPanel >
                            <apex:commandButton rerender="messages" action="{!EditSheet}" value="Update Sand Request" onclick="if(!confirm('Update this Sand Request?')){return false};" status="buttonstatus" />
                            <apex:commandButton rerender="none" action="{!RedirectViewSheet}" value="Cancel" onclick="if(!confirm('If you leave this page you will lose your changes.')){return false};" status="buttonstatus" immediate="true" />
                        </apex:outputPanel>
                    </apex:facet>

                    <apex:facet name="start">
                        <apex:outputPanel >
                            <apex:commandButton value="Update Sand Request" disabled="true" />
                            <apex:commandButton value="Cancel" disabled="true" />
                        </apex:outputPanel>
                    </apex:facet>

                </apex:actionstatus>
            </apex:pageBlockButtons>

            <apex:outputText value="Submitted on {0,date,MM'/'dd'/'yyyy}" style="font-weight: bold; font-size: 16px;" >
                <apex:param value="{!ViewSheet.Date__c}" /> 
            </apex:outputText>
    
            <apex:pageBlockSection id="pbs" columns="1" title="Location" collapsible="false">
                <apex:pageBlockSectionItem >
                    <apex:outputlabel >Operating Route</apex:outputlabel>
                    <apex:outputField value="{!ViewSheet.Well_Location__r.Route__c}" label="Operating Route" />
                </apex:pageBlockSectionItem>
        
                <apex:pageBlockSectionItem >
                    <apex:outputlabel >Location</apex:outputlabel>
                    <apex:outputField value="{!ViewSheet.Well_Location__c}" label="Location" />
                </apex:pageBlockSectionItem>

                <apex:pageBlockSectionItem >
                    <apex:outputlabel >Operator</apex:outputlabel>
                    <!-- <apex:outputField value="{!ViewSheet.Operator_Phone_Number__c}" label="Operator" /> -->
                    <apex:outputField value="{!ViewSheet.CreatedByID}" label="Operator" />
                </apex:pageBlockSectionItem>

            </apex:pageBlockSection>

            <apex:pageBlockSection columns="1" title="Well Information" collapsible="false">
            </apex:pageBlockSection>

                <table cellspacing="2" cellpadding="2" border="0">
                    <tr>
                        <td style="width: 130px;">&nbsp;</td>
                        <td style="font-weight: bold; text-align: right;">Cost Center</td>
                        <td style="width: 10px;">&nbsp;</td>
                        <td>
                            {!ViewSheet.Well_Location__r.Cost_Center__c}
                        </td>
                        <td style="width: 30px;">&nbsp;</td>
                        <td style="font-weight: bold; text-align: right;">Sand Lead</td>
                        <td style="width: 10px;">&nbsp;</td>
                        <td>
                            <apex:inputfield value="{!ViewSheet.Sand_Lead__c}" required="true" />
                        </td>
                    </tr>
                    <tr>
                        <td>&nbsp;</td>
                        <td style="font-weight: bold; text-align: right;">Surface Location</td>
                        <td>&nbsp;</td>
                        <td>
                            {!ViewSheet.Well_Location__r.Surface_Location__c}
                        </td>
                        <td>&nbsp;</td>
                        <td style="font-weight: bold; text-align: right;">Field Senior</td>
                        <td>&nbsp;</td>
                        <td>
                            <a target="_blank" href="/{!ViewSheet.Well_Location__r.Route__r.Field_Senior__r.Id}">{!ViewSheet.Well_Location__r.Route__r.Field_Senior__r.FirstName + ' ' + ViewSheet.Well_Location__r.Route__r.Field_Senior__r.LastName}</a>
                        </td>
                    </tr>
                    <tr>
                        <td>&nbsp;</td>
                        <td style="font-weight: bold; text-align: right;">Current Well Status</td>
                        <td>&nbsp;</td>
                        <td>
                            {!ViewSheet.Well_Location__r.Current_Well_Status__c}
                        </td>
                        <td>&nbsp;</td>
                        <td style="font-weight: bold; text-align: right;">RM</td>
                        <td>&nbsp;</td>
                        <td>
                            <apex:outputfield value="{!ViewSheet.RM__c}" />
                        </td>
                    </tr>
                    <tr>
                        <td>&nbsp;</td>
                        <td style="font-weight: bold; text-align: right;">Hazardous H2S</td>
                        <td>&nbsp;</td>
                        <td>
                            {!ViewSheet.Hazardous_H2s__c}
                        </td>
                        <td>&nbsp;</td>
                        <td style="font-weight: bold; text-align: right;">Water Transfer</td>
                        <td>&nbsp;</td>
                        <td>
                            <apex:outputfield value="{!ViewSheet.Water_Transfer__c}" />
                        </td>
                    </tr>
                    <tr>
                        <td>&nbsp;</td>
                        <td style="font-weight: bold; text-align: right;">Avg Oil Prod (m3)</td>
                        <td>&nbsp;</td>
                        <td>
                            <apex:outputfield value="{!ViewSheet.OIL_Prod_m3__c}" />
                        </td>
                        <td>&nbsp;</td>
                        <td style="font-weight: bold; text-align: right;">Avg Water Prod (m3)</td>
                        <td>&nbsp;</td>
                        <td>
                            <apex:outputfield value="{!ViewSheet.Water_Prod_m3__c}" />
                        </td>
                    </tr>
                    <!--AVERAGE SAND PRODUCTION-->
                    <tr>
                        <td>&nbsp;</td>
                        <td style="font-weight: bold; text-align: right;">Avg Sand Prod (m3)</td>
                        <td>&nbsp;</td>
                        <td>
                            <apex:outputfield value="{!oSelectedLocationPvr.PVR_AVGVOL_30D_SAND__c}" style="width: 60px;" />
                        </td>
                    </tr>
                    <tr>
                        <td>&nbsp;</td>
                        <td style="font-weight: bold; text-align: right;">Last H2S Reading</td>
                        <td>&nbsp;</td>
                        <td>
                            <apex:outputfield value="{!lH2S_Readings[0].H2S_Reading__c}" 
                            rendered="{!AND(lH2S_Readings<>null,lH2S_Readings.size>0)}" 
                            style="width: 60px;"/>
                            <br/>
                            <apex:outputfield value="{!lH2S_Readings[0].CreatedDate}" 
                            rendered="{!AND(lH2S_Readings<>null,lH2S_Readings.size>0)}" 
                            style="width: 60px;"/>                            
                        </td>
                        <!--
                        <td>&nbsp;</td>
                        <td style="font-weight: bold; text-align: right;">Current H2S Reading</td>
                        <td>&nbsp;</td>
                        <td>
                            <div>
                            <apex:inputfield value="{!NewH2SReading.Value__c}" style="width: 40px;" />
                            &nbsp;
                            <apex:inputfield value="{!NewH2SReading.UOM__c}"/>
                            </div>
                        </td>                        
                        -->
                    </tr>
                </table>

            <apex:outputPanel id="viewSheetDetailOutputPanel">
            <apex:repeat value="{!ViewSheetDetail}" var="sand" id="TankTableData">

                <apex:outputPanel id="editpanel" rendered="{!$CurrentPage.parameters.tank == '' || $CurrentPage.parameters.tank == sand.Id}">
                    <apex:pageBlockSection columns="1" title="{!sand.Tank__c}" collapsible="false">
                    </apex:pageBlockSection>

                    <table cellspacing="2" cellpadding="2" border="0">
                        <tr>
                            <td style="width: 130px; font-weight: bold; color: #0532F3">
                                <apex:outputText value="{!sand.Sand_Id__c}" />
                            </td>
                            <td style="width: 102px; font-weight: bold; text-align: right;">Sand Level (ft)</td>
                            <td style="width: 5px;">&nbsp;</td>
                            <td>
                                <apex:inputField value="{!sand.Sand_Level__c}" style="width: 50px;" required="{!sand.Sting_Type__c != 'Vault'}" rendered="{!sandDetailStatusMap[sand.id] != 'Closed'}"/>
                                <apex:outputField value="{!sand.Sand_Level__c}" style="width: 50px;" rendered="{!sandDetailStatusMap[sand.id] == 'Closed'}"/>
                            </td>
                            <td style="width: 5px;">&nbsp;</td>
                            <td style="width: 150px; font-weight: bold; text-align: right;">Location for Water (Well)</td>
                            <td style="width: 5px;">&nbsp;</td>
                            <td>
                                <apex:inputField value="{!sand.Location_for_Water_Well__c}" required="{!sand.Sting_Type__c != 'Vault'}" rendered="{!sandDetailStatusMap[sand.id] != 'Closed'}"/>
                                <apex:outputField value="{!sand.Location_for_Water_Well__c}" style="width: 50px;" rendered="{!sandDetailStatusMap[sand.id] == 'Closed'}"/>
                            </td>
                            <td style="width: 5px;">&nbsp;</td>
                            <td style="font-weight: bold; text-align: right;">Status</td>
                            <td>&nbsp;</td>
                            <td>
                                <apex:selectList value="{!sand.Status__c}" size="1" label="Status" required="true" rendered="{!sandDetailStatusMap[sand.id] != 'Closed' || IsHogAdmin == true}">
                                    <apex:selectOptions value="{!StingStatusList}" />
                                </apex:selectList>
                                <apex:outputField value="{!sand.Status__c}" style="width: 50px;" rendered="{!sandDetailStatusMap[sand.id] == 'Closed' && IsHogAdmin == false}"/>
                            </td>
                            <td colspan="3">&nbsp;</td>
                        </tr>
                        <tr>
                            <td>
                                <apex:inputField value="{!sand.Sting_Type__c}" style="width: 130px;" required="true" rendered="{!sandDetailStatusMap[sand.id] != 'Closed'}">
                                    <apex:actionSupport event="onchange" status="ajaxStatus" rerender="editpanel" />
                                </apex:inputField>
                                <apex:outputField value="{!sand.Sting_Type__c}" style="width: 130px;" rendered="{!sandDetailStatusMap[sand.id] == 'Closed'}"/>
                            </td>
                            <td style="font-weight: bold; text-align: right;">Water Level (ft)</td>
                            <td>&nbsp;</td>
                            <td>
                                <apex:inputField value="{!sand.Water_Level__c}" style="width: 50px;" required="{!sand.Sting_Type__c != 'Vault'}" rendered="{!sandDetailStatusMap[sand.id] != 'Closed'}"/>
                                <apex:outputField value="{!sand.Water_Level__c}" style="width: 50px;" rendered="{!sandDetailStatusMap[sand.id] == 'Closed'}"/>
                            </td>
                            <td>&nbsp;</td>
                            <td style="font-weight: bold; text-align: right;">Location for Water (Tank)</td>
                            <td>&nbsp;</td>
                            <td>
                                <apex:inputField value="{!sand.Location_for_Water_Tank__c}" required="{!sand.Sting_Type__c != 'Vault'}" rendered="{!sandDetailStatusMap[sand.id] != 'Closed'}"/>
                                <apex:outputField value="{!sand.Location_for_Water_Tank__c}" style="width: 50px;" rendered="{!sandDetailStatusMap[sand.id] == 'Closed'}"/>
                            </td>
                            <td>&nbsp;</td>
                            <apex:outputPanel layout="none" rendered="{!sand.Sting_Type__c == 'Door Pull'}">
                                <td style="font-weight: bold; text-align: right;">Work Order</td>
                                <td>&nbsp;</td>
                                <td>
                                    <apex:inputField value="{!sand.Work_Order__c}" style="width: 90px;" rendered="{!sandDetailStatusMap[sand.id] != 'Closed'}"/>
                                    <apex:outputField value="{!sand.Work_Order__c}" style="width: 50px;" rendered="{!sandDetailStatusMap[sand.id] == 'Closed'}"/>
                                </td>
                            </apex:outputPanel>
                            <apex:outputPanel layout="none" rendered="{!sand.Sting_Type__c != 'Door Pull'}">
                                <td style="font-weight: bold; text-align: right;">Vendor Date given out</td>
                                <td>&nbsp;</td>
                                <td>
                                    <apex:inputField value="{!sand.Vendor_Date_given_out__c}" rendered="{!sandDetailStatusMap[sand.id] != 'Closed'}"/>
                                    <apex:outputField value="{!sand.Vendor_Date_given_out__c}" style="width: 50px;" rendered="{!sandDetailStatusMap[sand.id] == 'Closed'}"/>
                                </td>
                            </apex:outputPanel>
                            <td colspan="3">&nbsp;</td>
                        </tr>
                        <tr>
                            <td>&nbsp;</td>
                            <td style="font-weight: bold; text-align: right;">Tank Level</td>
                            <td>&nbsp;</td>
                            <td>
                                <apex:inputField value="{!sand.Tank_Level__c}" required="{!sand.Sting_Type__c != 'Vault'}" style="width: 50px;" rendered="{!sandDetailStatusMap[sand.id] != 'Closed'}"/>
                                <apex:outputField value="{!sand.Tank_Level__c}" style="width: 50px;" rendered="{!sandDetailStatusMap[sand.id] == 'Closed'}"/>
                            </td>
                            <td>&nbsp;</td>
                            <td style="font-weight: bold; text-align: right;">Blow-off location</td>
                            <td>&nbsp;</td>
                            <td>
                                <apex:inputtext html-type="search"  id="blowOffTextBoxId" value="{!sand.Blow_off_location__c}" rendered="{!sandDetailStatusMap[sand.id] != 'Closed'}"/>
                                
                                    <script>
                                        var $ = jQuery.noConflict();

                                        var blowoffLocations;
                                        var queryTerm;
        
                                        var tempId = '{!$Component.blowOffTextBoxId}';
        
                                        $(esc(tempId)).autocomplete({
                                            minLength: 2,
                                            source: function(request, response) {
                                                        console.log(request.term);     
                                                        queryTerm = request.term;    
                                                        console.log('queryTerm :' + queryTerm );               
                                                        SM_RunSheetControllerX.searchBlowOffLocation(request.term, function(result, event){
                                                            if(event.type == 'exception') {
                                                                  alert(event.message);
                                                            } else {
                                                                 blowoffLocations = result;
                                                                 response(blowoffLocations);
                                                            }
                                                        });
                                                   },
                                            focus: function( event, ui ) {
                                                    $(this).val( ui.item.value );
                                                    return false;
                                                },
                                            select: function( event, ui ) {
                                                    $(this).val( ui.item.value );
                                                    return false;
                                                }
                                        }).data("ui-autocomplete")._renderItem = renItem;
                                        
                                        function renItem( ul, item ) {
                                            
                                            var entry = "<a>" + item.value + "</a>";
                                            //entry = highlight( entry , queryTerm );
                                            return $( "<li></li>" )
                                                .data( "ui-autocomplete-item", item )
                                                .append( entry )
                                                .appendTo( ul );
                                            
                                        };
                                       
                                        function esc(myid) {
                                           return '#' + myid.replace(/(:|\.)/g,'\\\\$1');
                                        }
                                    </script>

                        
                                <apex:outputField value="{!sand.Blow_off_location__c}" style="width: 50px;" rendered="{!sandDetailStatusMap[sand.id] == 'Closed'}"/>
                            </td>
                            <td>&nbsp;</td>
                            <apex:outputPanel layout="none" rendered="{!sand.Sting_Type__c == 'Door Pull'}">
                                <td style="font-weight: bold; text-align: right;">Vendor Date given out</td>
                                <td>&nbsp;</td>
                                <td>
                                    <apex:inputField value="{!sand.Vendor_Date_given_out__c}" rendered="{!sandDetailStatusMap[sand.id] != 'Closed'}"/>
                                    <apex:outputField value="{!sand.Vendor_Date_given_out__c}" style="width: 50px;" rendered="{!sandDetailStatusMap[sand.id] == 'Closed'}"/>
                                </td>
                            </apex:outputPanel>
                            <td colspan="3">&nbsp;</td>
                        </tr>
                        <tr>
                            <td>&nbsp;</td>
                            <td style="font-weight: bold; text-align: right;">Chem and rate</td>
                            <td>&nbsp;</td>
                            <td>
                                <apex:inputField value="{!sand.Chem_and_Rate__c}" style="width: 90px;" rendered="{!sandDetailStatusMap[sand.id] != 'Closed'}"/>
                                <apex:outputField value="{!sand.Chem_and_Rate__c}" style="width: 50px;" rendered="{!sandDetailStatusMap[sand.id] == 'Closed'}"/>
                            </td>
                            <td>&nbsp;</td>
                            <td style="font-weight: bold; text-align: right;">Flood Up</td>
                            <td>&nbsp;</td>
                            <td style="line-height: 10px; vertical-align: top;">
                                <apex:inputField value="{!sand.Flood_Up__c}" rendered="{!sandDetailStatusMap[sand.id] != 'Closed'}"/>
                                <apex:outputField value="{!sand.Flood_Up__c}" style="width: 50px;" rendered="{!sandDetailStatusMap[sand.id] == 'Closed'}"/>
                            </td>
                            <td>&nbsp;</td>
                            <td style="font-weight: bold; text-align: right;">Primary Vendor</td>
                            <td>&nbsp;</td>
                            <td style="line-height: 10px; vertical-align: top;">
                                
                                <!--apex:inputField value="{!sand.Primary_Vendor__c}" rendered="{!sandDetailStatusMap[sand.id] != 'Closed'}"/-->
                                
                                <apex:selectList value="{!sand.Primary_Vendor_PM__c}" size="1" rendered="{!sandDetailStatusMap[sand.id] != 'Closed'}">
                                    <apex:selectOption itemValue="" 
                                    itemLabel="- None -"/>
                                    <apex:selectOptions value="{!pmVendorPLvalues}"/>
                                </apex:selectList>
                                                                

                                <apex:outputField value="{!sand.Primary_Vendor__c}" style="width: 50px;" rendered="{!sandDetailStatusMap[sand.id] == 'Closed'}"/>
                            </td>
                            <td colspan="3">&nbsp;</td>
                        </tr>

                        <tr>
                            <td>&nbsp;</td>
                            <td style="font-weight: bold; text-align: right;">Priority</td>
                            <td>&nbsp;</td>
                            <td>
                                <apex:inputField value="{!sand.Priority__c}" required="true" rendered="{!sandDetailStatusMap[sand.id] != 'Closed'}"/>
                                <apex:outputField value="{!sand.Priority__c}" style="width: 50px;" rendered="{!sandDetailStatusMap[sand.id] == 'Closed'}"/>
                            </td>
                            <td>&nbsp;</td>
                            <td style="font-weight: bold; text-align: right;">Flowline push</td>
                            <td>&nbsp;</td>
                            <td style="line-height: 10px; vertical-align: top;">
                                <apex:inputField value="{!sand.Flowline_push__c}" rendered="{!
                                OR(sand.Sting_Type__c == 'Production Sting', 
                                sand.Sting_Type__c == 'Vault') && 
                                sandDetailStatusMap[sand.id] != 'Closed'}" />
                                <apex:outputField value="{!sand.Flowline_push__c}" rendered="{!
                                (sand.Sting_Type__c == 'Sting-to-Air' || sand.Sting_Type__c == 'Door Pull') || 
                                (OR(sand.Sting_Type__c == 'Production Sting',sand.Sting_Type__c == 'Vault') 
                                && sandDetailStatusMap[sand.id] == 'Closed')}" />
                            </td>

                            <td>&nbsp;</td>
                            <td style="font-weight: bold; text-align: right;">Primary Disposal</td>
                            <td>&nbsp;</td>
                            <td style="line-height: 10px; vertical-align: top;">

                                <apex:selectList value="{!pmDestOrFacId}" size="1" rendered="{!sandDetailStatusMap[sand.id] != 'Closed'}">
                                    <apex:selectOption itemValue="" 
                                    itemLabel="- None -"/>
                                    <apex:selectOptions value="{!lDestinationLocations}"/>
                                </apex:selectList>

                                <apex:outputField value="{!sand.Primary_Disposal_Facility__c}" style="width: 50px;" rendered="{!sandDetailStatusMap[sand.id] == 'Closed' && sand.Primary_Disposal_Facility__c != null}"/>
                                <apex:outputField value="{!sand.Disposal_Destination__c}" style="width: 50px;" rendered="{!sandDetailStatusMap[sand.id] == 'Closed' && sand.Primary_Disposal_Facility__c == null}" />
                            </td> 

                            <td colspan="3">&nbsp;</td>
                        </tr>
                        <tr>
                            <td>&nbsp;</td>
                            <td style="font-weight: bold; text-align: right;">Comments</td>
                            <td>&nbsp;</td>
                            <td colspan="8">
                                <apex:inputField value="{!sand.Comments__c}" style="width: 80%;" rendered="{!sandDetailStatusMap[sand.id] != 'Closed'}"/>
                                <apex:outputField value="{!sand.Comments__c}" style="width: 50px;" rendered="{!sandDetailStatusMap[sand.id] == 'Closed'}"/> 
                            </td>
                            <td colspan="3">&nbsp;</td>
                        </tr>

                        <tr>
                            <td colspan="18">&nbsp;</td>
                        </tr>
                        
                        <tr>
<!--                             <td>&nbsp;</td>
                            <td colspan="15"> -->

                            <td colspan="18">
                                <apex:outputPanel id="vendorTable" rendered="{!sandDetailStatusMap[sand.id] != 'Closed'}">
                                    <table cellspacing="4" cellpadding="4" style="width:100%;border-collapse:collapse">
                                        <caption style="color: #0532f3;font-weight:bold">Vendor Information</caption>
                                        <thead>
                                        <tr>
                                            <th>Action</th>
                                            <th class="vendorTable">{!$ObjectType.SM_Sand_Request_Vendor_Ticket__c.Fields.Vendor__c.Label}</th>
                                            <th class="vendorTable">{!$ObjectType.SM_Sand_Request_Vendor_Ticket__c.Fields.Invoice_Number__c.Label}</th>

                                            <th class="vendorTable">{!$ObjectType.SM_Sand_Request_Vendor_Ticket__c.Fields.Ticket_Date__c.Label}</th>
                                            <th class="vendorTable">{!$ObjectType.SM_Sand_Request_Vendor_Ticket__c.Fields.Ticket_Number__c.Label}</th>
                                            <th class="vendorTable">{!$ObjectType.SM_Sand_Request_Vendor_Ticket__c.Fields.Truck_Type__c.Label}</th>
                                            <th class="vendorTable">{!$ObjectType.SM_Sand_Request_Vendor_Ticket__c.Fields.Unit_Number__c.Label}</th>
                                            <th class="vendorTable">{!$ObjectType.SM_Sand_Request_Vendor_Ticket__c.Fields.Ticket_Hours__c.Label}</th>
                                            <th class="vendorTable">Ticket<br/>Volume (m3)</th>
                                            <th class="vendorTable">{!$ObjectType.SM_Sand_Request_Vendor_Ticket__c.Fields.Disposal_Facility__c.Label}</th>
                                            <th class="vendorTable" style="word-wrap: break-word; width:70px" >
                                                    Disposal Location<br/>Invoice #
                                            </th>
                                            <th class="vendorTable" style="word-wrap: break-word; width:70px">Disposal Fluid<br/>Volume (m3)</th>
                                            <th class="vendorTable" style="word-wrap: break-word; width:70px">Disposal Solids<br/>Volume (m3)</th>                                            
                                            <th class="vendorTable" style="word-wrap: break-word; width:70px">
                                                Disposal Invoiced<br/>Volume (m3)
                                            </th>

                                        </tr>
                                        </thead>
                                        <tbody>
                                            <apex:variable value="{!0}" var="rowNum"/>  
                                            <apex:repeat value="{!ViewVendorDetailWrapper}" var="vendor">
                                                <apex:outputPanel layout="none" rendered="{!vendor.vendorTicket.Sand_Request__c == sand.Id}">
                                                    <apex:outputPanel layout="none" rendered="{!sandDetailVendorCountMap[sand.Id] > 0}">
                                                        <tr> 
                                                            <td>
                                                                <apex:commandLink value="Remove" action="{!removeVendorLine}" style="color:red" 
                                                                    onclick="if (!confirm('Removal of vendor information cannot be undone.  Are you sure?')) {return false;}" 
                                                                    immediate="true" reRender="vendorTable">
                                                                    <apex:param value="{!rowNum}" name="rowNum" assignTo="{!rowToRemove}" /> 
                                                                    <apex:param value="{!sand.Id}" name="sandRequestId" assignTo="{!sandRequestId}" />
                                                                </apex:commandLink>
                                                            </td>
                                                            <!--td class="vendorTable"><apex:inputField required="true" value="{!vendor.Vendor__c}" /></td-->
                                                            <!--mz 8.6.2016-->
                                                            <td class="vendorTable">
                                                            <apex:selectList value="{!vendor.vendorTicket.Vendor_PM__c}" size="1">
                                                                <apex:selectOption itemValue="" 
                                                                itemLabel="- None -"/>
                                                                <apex:selectOptions value="{!pmVendorPLvalues}"/>
                                                            </apex:selectList>          
                                                            </td>

                                                            <td class="vendorTable"><apex:inputField value="{!vendor.vendorTicket.Invoice_Number__c}" style="width:70px" /></td>                                                            

                                                            <td class="vendorTable"><apex:inputField value="{!vendor.vendorTicket.Ticket_Date__c}" style="width:80px"/></td>
                                                            <td class="vendorTable"><apex:inputField value="{!vendor.vendorTicket.Ticket_Number__c}" style="width:70px"/></td>

                                                            <!--td class="vendorTable"><apex:inputField value="{!vendor.Truck_Type__c}" /></td-->
                                                            <!--*mz 8.6.2016-->
                                                            <td class="vendorTable">
                                                            <apex:selectList value="{!vendor.vendorTicket.Truck_Type_PM__c}" size="1">
                                                                <apex:selectOption itemValue="" 
                                                                itemLabel="- None -"/>
                                                                <apex:selectOptions value="{!pmUnitTypePLvalues}"/>
                                                            </apex:selectList>          
                                                            </td>

                                                            <td class="vendorTable"><apex:inputField value="{!vendor.vendorTicket.Unit_Number__c}" style="width:70px"/></td>

                                                            <td class="vendorTable"><apex:inputField value="{!vendor.vendorTicket.Ticket_Hours__c}" style="width:40px"/></td>

                                                            <td class="vendorTable"><apex:inputField value="{!vendor.vendorTicket.Ticket_Volume_m3__c}" style="width:40px"/></td>                                                            
                                                            <td class="vendorTable">
                                                            <!-- <apex:inputField value="{!vendor.Disposal_Facility__c}" /> -->
                                                            <apex:selectList value="{!vendor.destinationId}" size="1">
                                                                <apex:selectOption itemValue="" 
                                                                itemLabel="- None -"/>
                                                                <apex:selectOptions value="{!lDestinationLocations}"/>
                                                            </apex:selectList>
                                                            </td>



                                                            <td class="vendorTable"><apex:inputField value="{!vendor.vendorTicket.Disposal_Location_Invoice_Number__c}" style="width:70px"/></td>

                                                            <td class="vendorTable"><apex:inputField value="{!vendor.vendorTicket.Disposal_Fluid_Volume__c}" style="width:40px"/></td>
                                                            <td class="vendorTable"><apex:inputField value="{!vendor.vendorTicket.Disposal_Solids_Volume__c}" style="width:40px"/></td> 

                                                            <td class="vendorTable"><apex:inputField value="{!vendor.vendorTicket.Disposal_Location_Invoiced_Volume__c}" style="width:40px"/></td>                                                            
                                                        </tr>
                                                    </apex:outputPanel>
                                                </apex:outputPanel>
                                                <apex:variable value="{!rowNum+1}" var="rowNum"/>  
                                            </apex:repeat>
                                            <apex:outputPanel layout="none" rendered="{!sandDetailVendorCountMap[sand.Id] == 0}">
                                                <tr>
                                                    <td colspan="7">No vendor information has been entered for this Sand Request yet.</td>
                                                </tr>
                                            </apex:outputPanel>
                                            <tr>
                                                <td>
                                                    <apex:commandButton value="Add More" action="{!addVendorLine}" reRender="vendorTable" Status="status" immediate="true" >
                                                        <apex:param value="{!sand.Id}" name="sandRequestId" assignTo="{!sandRequestId}" />
                                                    </apex:commandButton>
                                                </td>
                                            </tr>
                                        </tbody>
                                    </table>
                                </apex:outputPanel>
                                <apex:outputPanel rendered="{!sandDetailStatusMap[sand.id] == 'Closed'}">
                                    <table cellspacing="2" cellpadding="2" style="width:100%;border-collapse:collapse">
                                        <caption style="color: #0532f3;font-weight:bold">Vendor Information</caption>
                                        <thead>
                                        <tr>
<!--                                             <th class="vendorTable">{!$ObjectType.SM_Sand_Request_Vendor_Ticket__c.Fields.Vendor__c.Label}</th>
                                            <th class="vendorTable">{!$ObjectType.SM_Sand_Request_Vendor_Ticket__c.Fields.Truck_Type__c.Label}</th>
                                            <th class="vendorTable">{!$ObjectType.SM_Sand_Request_Vendor_Ticket__c.Fields.Unit_Number__c.Label}</th>
                                            <th class="vendorTable">{!$ObjectType.SM_Sand_Request_Vendor_Ticket__c.Fields.Ticket_Date__c.Label}</th>
                                            <th class="vendorTable">{!$ObjectType.SM_Sand_Request_Vendor_Ticket__c.Fields.Ticket_Number__c.Label}</th>
                                            <th class="vendorTable">{!$ObjectType.SM_Sand_Request_Vendor_Ticket__c.Fields.Ticket_Hours__c.Label}</th>
                                            <th class="vendorTable">{!$ObjectType.SM_Sand_Request_Vendor_Ticket__c.Fields.Disposal_Facility__c.Label}</th>
                                            <th class="vendorTable">{!$ObjectType.SM_Sand_Request_Vendor_Ticket__c.Fields.Ticket_Volume_m3__c.Label}</th> -->
                                            <th class="vendorTable">{!$ObjectType.SM_Sand_Request_Vendor_Ticket__c.Fields.Vendor__c.Label}</th>
                                            <th class="vendorTable">{!$ObjectType.SM_Sand_Request_Vendor_Ticket__c.Fields.Invoice_Number__c.Label}</th>

                                            <th class="vendorTable">{!$ObjectType.SM_Sand_Request_Vendor_Ticket__c.Fields.Ticket_Date__c.Label}</th>
                                            <th class="vendorTable">{!$ObjectType.SM_Sand_Request_Vendor_Ticket__c.Fields.Ticket_Number__c.Label}</th>
                                            <th class="vendorTable">{!$ObjectType.SM_Sand_Request_Vendor_Ticket__c.Fields.Truck_Type__c.Label}</th>
                                            <th class="vendorTable">{!$ObjectType.SM_Sand_Request_Vendor_Ticket__c.Fields.Unit_Number__c.Label}</th>
                                            <th class="vendorTable">{!$ObjectType.SM_Sand_Request_Vendor_Ticket__c.Fields.Ticket_Hours__c.Label}</th>
                                            <th class="vendorTable">Ticket<br/>Volume (m3)</th>
                                            <th class="vendorTable">{!$ObjectType.SM_Sand_Request_Vendor_Ticket__c.Fields.Disposal_Facility__c.Label}</th>
                                            <th class="vendorTable">Disposal Location<br/>Invoice #</th>
                                            <th class="vendorTable">Disposal Fluid<br/>Volume (m3)</th>
                                            <th class="vendorTable">Disposal Solids<br/>Volume (m3)</th>
                                            <th class="vendorTable">Disposal Invoiced<br/> Volume (m3)</th>                                            
                                        </tr>
                                        </thead>
                                        <tbody>
                                            <apex:repeat value="{!ViewVendorDetailWrapper}" var="vendor">
                                                <apex:outputPanel rendered="{!vendor.vendorTicket.Sand_Request__r.Id == sand.Id}">
                                                    <apex:outputPanel rendered="{!sandDetailVendorCountMap[vendor.vendorTicket.Sand_Request__r.Id] > 0}">
                                                        <tr> 
                                                            <td class="vendorTable"><apex:outputField value="{!vendor.vendorTicket.Vendor__c}" /></td>
                                                            <td class="vendorTable"><apex:outputField value="{!vendor.vendorTicket.Invoice_Number__c}" /></td>                                                            
                                                            <td class="vendorTable"><apex:outputField value="{!vendor.vendorTicket.Ticket_Date__c}" /></td>
                                                            <td class="vendorTable"><apex:outputField value="{!vendor.vendorTicket.Ticket_Number__c}" /></td>
                                                            <td class="vendorTable"><apex:outputField value="{!vendor.vendorTicket.Truck_Type__c}" /></td>
                                                            <td class="vendorTable"><apex:outputField value="{!vendor.vendorTicket.Unit_Number__c}" /></td>

                                                            <td class="vendorTable"><apex:outputField value="{!vendor.vendorTicket.Ticket_Hours__c}" /></td>
                                                            <td class="vendorTable"><apex:outputField value="{!vendor.vendorTicket.Ticket_Volume_m3__c}" /></td>
                                                            <td class="vendorTable">
                                                                <apex:outputField value="{!vendor.vendorTicket.Disposal_Facility__c}" rendered="{!vendor.vendorTicket.Disposal_Facility__c != null}" />
                                                                <apex:outputField value="{!vendor.vendorTicket.Disposal_Location_Name__c}" rendered="{!vendor.vendorTicket.Disposal_Facility__c == null}"/>
                                                             </td>
                                                            <td class="vendorTable"><apex:outputField value="{!vendor.vendorTicket.Disposal_Location_Invoice_Number__c}" /></td>
                                                            <td class="vendorTable"><apex:outputField value="{!vendor.vendorTicket.Disposal_Fluid_Volume__c}" /></td>
                                                            <td class="vendorTable"><apex:outputField value="{!vendor.vendorTicket.Disposal_Solids_Volume__c}" /></td>
                                                            <td class="vendorTable"><apex:outputField value="{!vendor.vendorTicket.Disposal_Location_Invoiced_Volume__c}" /></td>


                                                        </tr>
                                                    </apex:outputPanel>
                                                </apex:outputPanel>
                                            </apex:repeat>
                                            <apex:outputPanel rendered="{!sandDetailVendorCountMap[sand.Id] == 0}">
                                                <tr>
                                                    <td colspan="7">No vendor information has been entered for this Sand Request yet.</td>
                                                </tr>
                                            </apex:outputPanel>
                                </tbody>
                            </table>
                                </apex:outputPanel>
                            </td>
                        </tr>


                    </table>
    
                    <br />
                </apex:outputPanel>

            </apex:repeat>
            </apex:outputPanel>
        </apex:pageBlock>
    </apex:form>
</apex:page>